--[[/*Classic Ring Attraction script by Golden.
I commented this whole thing out because it causes a lot of lag... like, a LOT.
Turns out attaching a script to EVERY SINGLE RING IN A LEVEL will do that. Go figure.
It still works mostly okay on small levels though, so I'll leave it in for anyone that wants to mess around with it.
To make the script work again, simply move the double brackets on line 137 to the end of line 14.
Also note, this script is modified - originally, it only affected Magnet and Lightning shields.
Now, it'll activate whenever you go Super instead.

Replicates how rings attract to the player in Sonic 3 and Sonic Mania.

Lua people:
To make your object also be effected by this script,
just hook it into MobjThinker with the function A_ClassicRingAttract like so:
	addHook("MobjThinker", A_ClassicRingAttract, MT_CYBRAKDEMON)*/
COM_AddCommand("supermagnet",function(player,value)							--tbh i'm not even really sure what i did to get this thing working
	if not(player and player.valid and player.mo)							--i just kinda messed around with stuff until it worked
		CONS_Printf(player,"This command can only be used inside a level.")	--but hey, it worked i guess, so i'll take it
		return
	elseif player.mo.skin~="skyfox"
		CONS_Printf(player,"You must be playing as SkyFox to use this command.")
		return
	end
	if value=="0"or value=="no"or value=="off"or value=="false"
		player.supermagnet=0
		CONS_Printf(player,"Super ring attraction disabled.")
	elseif value=="1"or value=="yes"or value=="on"or value=="true"
		player.supermagnet=1
		CONS_Printf(player,"Super ring attraction enabled.")
	else
		if player.supermagnet==1
			CONS_Printf(player,"supermagnet is on. Default is off.")
		else
			CONS_Printf(player,"supermagnet is off. Default is off.")
		end
	end
end,1)
-- A list of objects to hook immediately during load.
local objects={MT_RING,MT_FLINGRING}
-- Change an object's type without deleting it.
-- Not globalising because I don't want to cause
-- people to actually use this.
local function changeObjectType(mo,newType)
	mo.type=newType
	local info=mobjinfo[newType]
	-- Set several mobj variables to their new defaults.
	mo.health=info.spawnhealth
	mo.reactiontime=info.reactiontime
	mo.radius=info.radius
	mo.height=info.height
	mo.flags=info.flags
end
-- Apply ring momentum for ring attraction.
-- [12:40 AM] MT_FLAME: ["mom" .. dimension] is extremely crafty
local function doRingMomentum(mo,dimension)
	-- where dimension=="x"
	-- mo[dimension]==mo.x
	-- mo["mom"..dimension]==mo.momx
	local followmo=mo.followmo
	-- When moving toward player, accelerate fast
	-- When moving away from player, accelerate slow
	-- Always try to go towards player.
	if followmo[dimension]>mo[dimension]
		if mo["mom" .. dimension]>followmo["mom" .. dimension]
			mo["mom" .. dimension]=$+FRACUNIT*4
		else
			mo["mom" .. dimension]=$+FRACUNIT*8
		end
	elseif followmo[dimension]<mo[dimension]
		if mo["mom" .. dimension]<followmo["mom" .. dimension]
			mo["mom" .. dimension]=$-FRACUNIT*4
		else
			mo["mom" .. dimension]=$-FRACUNIT*8
		end
	end
end
-- Perform classic ring attraction. And many checks. Soo many checks.
function A_ClassicRingAttract(mo)
	-- Don't attract the rancid decomposing dead rings!
	if mo.health==0
		mo.followmo=nil
		return
	end
	-- Check if player exists and is in range, and if so, link them to us.
	-- Otherwise, don't continue.
	if not mo.followmo or not mo.followmo.valid
	or not mo.followmo.player or not mo.followmo.player.valid
	or mo.followmo.player.mo.skin=="skyfox"
	and mo.followmo.player.supermagnet==1
		local target=mo.target--Get current target, cause P_SupermanLook4Players overwrites it.
		local success=P_SupermanLook4Players(mo,0,true)
		if success then
			if P_AproxDistance(P_AproxDistance(mo.x-mo.target.x,mo.y-mo.target.y),mo.z-mo.target.z)>RING_DIST
				mo.target=target
				return
			end
			mo.followmo=mo.target
			mo.target=target
		else
			return
		end
	end
	local followmo=mo.followmo
	--If the player doesn't have electrical protection, fling off!--haha i change it, now it will attract rings while you're super
	if followmo.player.mo.skin=="skyfox"
	and followmo.player.powers[pw_super]==0
	and followmo.player.supermagnet==1
		mo.flags=$&~MF_NOCLIP&~MF_NOCLIPHEIGHT&~MF_NOGRAVITY
		mo.followmo=nil
		if mo.attractive--But only if we're too good for them.
			if mo.type==MT_RING
				changeObjectType(mo,MT_FLINGRING)
				mo.fuse=8*TICRATE
			end
			mo.attractive=false--Someone forgot to put on makeup...
		end
		return
	else
		mo.attractive=true--We're beautiful
	end
	if followmo.player.mo.skin=="skyfox"
	and mo.followmo.player.supermagnet==1
		mo.fuse=0--Never disappear
		mo.flags=$|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY--Go through everythin
		-- Do the actual movement
		doRingMomentum(mo,"x")
		doRingMomentum(mo,"y")
		doRingMomentum(mo,"z")
		mo.state=mo.state--Update state
		P_TeleportMove(mo,mo.x+mo.momx,mo.y+mo.momy,mo.z+mo.momz)--Update position using momentum.
		return true--Skip ring thinker.
	end
end
--For each object type in objects, hook A_ClassicRingAttract to their thinker.
--Yes, this is valid Lua code.
for i,v in ipairs(objects) do
	addHook("MobjThinker",A_ClassicRingAttract,v)
end]]